package org.xdoclet.plugin.jmx.qtags;

public class JmxManagedAttributeTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.jmx.qtags.JmxManagedAttributeTag {
    public static final String NAME = "jmx.managed-attribute";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"access",
		"description",
		"persist-policy",
		"persist-period",
		"persist-location",
		"persist-name",
		"currency-time-limit",
		"state-action-on-update",
		"value",
		"descriptor",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JmxManagedAttributeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JmxManagedAttributeTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("read-only")|| result.equals("write-only")|| result.equals("read-write")) ) {
	                // todo we should say what file and line number too
	                bomb("access=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersistPolicy() {
		boolean required = false;
        String result = getNamedParameter("persist-policy");
        if(required && result == null) {
            bomb("persist-policy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("OnUpdate")|| result.equals("NoMoreOftenThan")|| result.equals("Never")|| result.equals("OnTimer")) ) {
	                // todo we should say what file and line number too
	                bomb("persist-policy=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersistPeriod() {
		boolean required = false;
        String result = getNamedParameter("persist-period");
        if(required && result == null) {
            bomb("persist-period=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersistLocation() {
		boolean required = false;
        String result = getNamedParameter("persist-location");
        if(required && result == null) {
            bomb("persist-location=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersistName() {
		boolean required = false;
        String result = getNamedParameter("persist-name");
        if(required && result == null) {
            bomb("persist-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCurrencyTimeLimit() {
		boolean required = false;
        String result = getNamedParameter("currency-time-limit");
        if(required && result == null) {
            bomb("currency-time-limit=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getStateActionOnUpdate() {
		boolean required = false;
        String result = getNamedParameter("state-action-on-update");
        if(required && result == null) {
            bomb("state-action-on-update=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValue_() {
		boolean required = false;
        String result = getNamedParameter("value");
        if(required && result == null) {
            bomb("value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescriptor() {
		boolean required = false;
        String result = getNamedParameter("descriptor");
        if(required && result == null) {
            bomb("descriptor=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getAccess();
        getDescription();
        getPersistPolicy();
        getPersistPeriod();
        getPersistLocation();
        getPersistName();
        getCurrencyTimeLimit();
        getStateActionOnUpdate();
        getValue_();
        getDescriptor();
    }

    public void validateModel() {
        // check uniqueness
    }
}